#include "lista.h"
#include <stdio.h>
#include <stdlib.h>


void wypisz( struct Lista *lista )
{
  if( lista==0 )
    return;
  printf( "Element listy:%s\n",lista->nazwa);
  wypisz( lista->nastepny );
}


void wypiszwstecz( struct Lista *lista )
{
  for ( ; lista!=0; lista=lista->poprzedni )
    printf( "Element listy:%s\n",lista->nazwa);  
}



struct Lista* znajdzostatni( struct Lista *lista )
{
  if( lista==0 )
    return 0;
  for(; lista->nastepny!=0; lista=lista->nastepny);
  return lista;  
}

struct Lista* znajdzpierwszy( struct Lista *lista )
{
  if( lista==0 )
    return 0;
  for(; lista->poprzedni!=0; lista->poprzedni=lista->poprzedni);
  return lista;  
}


struct Lista* dodajza( struct Lista *lista, char *nowanazwa )
{
  struct Lista *nowyelement;
  
  nowyelement=malloc(sizeof(struct Lista));
  nowyelement->nazwa=nowanazwa;
  if(lista==0)
  {
    nowyelement->nastepny=0;
    nowyelement->poprzedni=0;
    return nowyelement;
  }
  nowyelement->nastepny=lista->nastepny;
  nowyelement->poprzedni=lista;
  lista->nastepny=nowyelement;
  if( nowyelement->nastepny!=0 )
     nowyelement->nastepny->poprzedni=nowyelement;
  return nowyelement;
}

struct Lista* dodajprzed( struct Lista *lista, char *nowanazwa )
{
  struct Lista *nowyelement;

  nowyelement=malloc(sizeof(struct Lista));
  nowyelement->nazwa=nowanazwa;
  if(lista==0)
  {
    nowyelement->nastepny=0;
    nowyelement->poprzedni=0;
    return nowyelement;
  }
  nowyelement->nastepny=lista;
  nowyelement->poprzedni=lista->poprzedni;
  lista->poprzedni=nowyelement;
  nowyelement->poprzedni->nastepny=nowyelement;
  return nowyelement; 
}
