#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "lines.h"
#include "myfiles.h"

static int getword(FILE* f,int c,char** wo)
{
  int i;
  int kon;

  (*wo)=malloc(20*sizeof(char));
  // takie rozwiazanie stwarza mozliwosc dynamicznego mierzenia rozmiaru
  // tekstu wczytywanego
  i=0;
  kon=1;
  while (c!=EOF && kon)
    switch (c) {
      case '\n':
      case '\t':
      case ' ':
        kon=0;
        *((*wo)+i)=(char) 0;
	break;
      default: 
	*((*wo)+i)=(char) c;
	i++;
	c=fgetc(f);
	break;
    }
  return c;
}

static int skipblanks(FILE* f,int c)
{
  int kon = 1;
  
  while (c!=EOF && c!='\n' && kon) 
    switch (c) {
      case '\n':
      case '\t':
      case ' ':
        c=fgetc(f); 
	break;
      default: 
	kon = 0;
	break;
    }
  return c;
}

static int readline(int c, FILE* f,struct line** li)
{
  char *l;

  while (c!=EOF && c!='\n') 
    {
      c=skipblanks(f,c);
      c=getword(f,c,&l);
      addword(li, l);
      free(l);
    }
  return c;
}

struct lines* readfile(const char *file_name)
{
  FILE *f;
  int c;
  char *l;
  struct line *li;
  struct lines *res;

  li=NULL;
  res=NULL;
  l=NULL;
  f = (!strcmp(file_name,"-")) ? stdin : fopen(file_name, "r");
  c=0;
  if (f==NULL)
    return NULL;
  else {
    c=fgetc(f);
    while (c!=EOF) {
      li=NULL;
      c=readline(c,f,&li);
      /* pow. alokujemy nowe li */
      
      addline(&res, li);
      /* pow. zapamietujemy zaalokowane li w res */
      /* dealokacja res powoduje dealokacje tekstu zaalokowanego pod li */
    }
    return res;
  }
}

