#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "lista.h"
#include "czytaj.h"

static char* czytajlinie(FILE* f)
{
  char *bufor;
  int wielkoscbufora;
  int przeczytano;
  char c;

  wielkoscbufora=16;
  przeczytano=0;
  bufor=malloc(wielkoscbufora);
  
  c=fgetc(f);
  while(c!=EOF && c!='\n')
  {
    *(bufor+przeczytano)=c;
    przeczytano++;
    if(przeczytano+1==wielkoscbufora)
    {
      char *buforpomocniczy;
      
      wielkoscbufora+=16;
      bufor=malloc(wielkoscbufora);
      memcpy(bufor,buforpomocniczy,przeczytano);
      free(buforpomocniczy);
    }
    c=fgetc(f);
  }
  
  if(przeczytano==0 && c!='\n')
  {
    free(bufor);
    return NULL;
  }
  
  bufor[przeczytano]=0;
  return bufor;
}


struct Lista* czytajpokolei(const char *file_name)
{
  FILE *f;
  struct Lista *aktualna;
  char *linia;

  f = fopen(file_name, "r");
 
  if (f==NULL)
    return NULL;
  
  aktualna=NULL;
  
  for( linia=czytajlinie(f); linia!=NULL; )
  {
    aktualna=dodajza(znajdzostatni(aktualna),linia);
    linia=czytajlinie(f);
  }
  
  fclose(f); 
  
  return aktualna;
}

struct Lista* czytajnazmiane(const char *file_name)
{
  FILE *f;
  struct Lista *aktualna;
  char *linia;

  f = fopen(file_name, "r");
 
  if (f==NULL)
    return NULL;
  
  aktualna=NULL;
  
  for( linia=czytajlinie(f); linia!=0; )
  {
    aktualna=dodajza(znajdzostatni(aktualna),linia);
    linia=czytajlinie(f);
    aktualna=dodajprzed(znajdzpierwszy(aktualna),linia);
    linia=czytajlinie(f); 
  }
  
  fclose(f); 
  
  return aktualna;
}