#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "lines.h"


void addword(struct line** l, char* w)
{
  struct line *akt;

  akt=*l;
  if (akt!=NULL) {
    for (akt=(*l); 
	 (*akt).next_field!=NULL; 
	 akt=(struct line*)(*akt).next_field);
    (struct line*)(*akt).next_field=malloc(sizeof(struct line));
    akt=(struct line*)(*akt).next_field;
  } else {
    (*l)=malloc(sizeof(struct line));
    akt=(*l);
  }
  (*akt).next_field=NULL;
  (*akt).field=malloc((strlen(w)+1)*sizeof(char));
  strcpy((*akt).field, w);
}

void deletewords(struct line** l)
{
  if ((*l)!=NULL) {
    if ((*(*l)).next_field!=NULL)
      deletewords((struct line**)  &(*(*l)).next_field);
    free((*(*l)).field);
    free(*l);
  }
}

//tu nie kopiujemy calej struktury
void addline(struct lines** l, struct line* w)
{
  struct lines *akt;

  akt=*l;
  if (akt!=NULL) {
    for (akt=(*l); 
	 (*akt).next_field!=NULL; 
	 akt=(struct lines*)(*akt).next_field);
    (struct lines*)(*akt).next_field=malloc(sizeof(struct lines));
    akt=(struct lines*)(*akt).next_field;
  } else {
    (*l)=malloc(sizeof(struct lines));
    akt=(*l);
  }
  (*akt).next_field=NULL;
  (*akt).field= w;
}

void deletelines(struct lines** l)
{
  if ((*l)!=NULL) {
    if ((*(*l)).next_field!=NULL)
      deletelines( ((struct lines**) &((*(*l)).next_field)));
    deletewords((struct line**) &(*(*l)).field);
    free(*l);
  }
}

